#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os,sys
from google.appengine.api import users
from google.appengine.ext import webapp
from google.appengine.ext.webapp import template
from models  import * # Model
from helpers import * # Helper

class Helper(webapp.RequestHandler, ApplicationHelper):
    def dispatch(self, template_name, vals):
        self.response.out.write(template.render(\
            self.render(template_name), vals))

req	= ''

class Index(Helper):
    def get(self):
        user = users.get_current_user()
        if not user:
            self.redirect(users.create_login_url(self.request.uri))

        query	= Post().all()					# S擾
        # props̏
        propsa	= query
        i		= 0
        props	= []
        for x in propsa:						# ٰ̕
        	if i == 0:							# 
        		props.append(x.indx)			# Ɋi[
        	else:								# ȊO
        		sw	= 0							# m邩OFFŏ
        		for y in props:					# łɊi[ٰ
        			if y == x.indx:				# łɊi[Ɠ̂ꍇ
        				sw	= 1					# ONƂ
        		if sw == 0:						# OFFłȂ
        			props.append(x.indx)		# ̂̂Ŋi[
        	i	+= 1							# ı
        req		= self.request.get('req')		# Ǎ
        pge		= self.request.get('pge')		# Ǎ
        if req=='' or pge=='':				# ŗ̏ꍇ
        	itemsa	= query.order('-updated_at')	# ŐVްi[
        	items	= []
        	for x in itemsa:					# łɊi[ٰ
        		items.append(x)
        		break
        	fst	= 1
        else:
        	# req pgȅ
        	req		= int(req)						# lɕϊ
        	pge		= int(pge)						# lɕϊ
        	# items̏
        	if props:
        		items	= query.filter('indx = ',props[req])	# indxpropsreqԖڂɊYްi[
        	else:
        		items	= []
        	fst	= 0

        template_vals = {
                'fst': fst,
                'indxnb': req,
                'pgenb': pge,
                'props': props,
                'user': user,
                'items': items,
            }
        self.dispatch('menu.html', template_vals)

class Setting(Helper):
    def get(self):
        user = users.get_current_user()
        if not user:
            self.redirect(users.create_login_url(self.request.uri))

        user = users.get_current_user()
        template_vals = {
                'user': user,
            }
        self.dispatch('setting.html', template_vals)

class New(Helper):
    def get(self):
        user = users.get_current_user()
        if not users.is_current_user_admin():
            self.redirect(users.create_login_url(self.request.uri))

        user = users.get_current_user()
        template_vals = {
                'user': user,
            }
        self.dispatch('new.html', template_vals)

class Edit(Helper):
    def get(self):
        user = users.get_current_user()
        if not users.is_current_user_admin():
            self.redirect(users.create_login_url(self.request.uri))

        radio	= self.request.get('radio')		# Ǎ
        indxnb	= self.request.get('indxnb')	# Ǎ
        if indxnb == '':						# ŋ̏ꍇ
        	indxnb	= 0							# 0i[
        indxnb	= int(indxnb)
        pgenb	= self.request.get('pgenb')		# Ǎ
        if pgenb == '':							# ŋ̏ꍇ
        	pgenb	= 0							# 0i[
        pgenb	= int(pgenb)
        query	= Post().all()					# S擾
        # props̏
        propsa	= query
        i		= 0
        props	= []
        for x in propsa:						# ٰ̕
        	if i == 0:							# 
        		props.append(x.indx)			# Ɋi[
        	else:								# ȊO
        		sw	= 0							# m邩OFFŏ
        		for y in props:					# łɊi[ٰ
        			if y == x.indx:				# łɊi[Ɠ̂ꍇ
        				sw	= 1					# ONƂ
        		if sw == 0:						# OFFłȂ
        			props.append(x.indx)		# ̂̂Ŋi[
        	i	+= 1							# ı

        # item̏
        query	= Post().all()					# S擾
        items	= query.filter('indx = ',props[indxnb])	# indxpropsreqԖڂɊYްi[
        i		= query.filter('indx = ',props[indxnb]).count() - 1
        item	= []
        for x in items:
        	if i == pgenb:
        		item.append(x)
        	i	-= 1

        user = users.get_current_user()
        template_vals = {
                'radio': radio,
                'item': item,
                'user': user,
            }
        self.dispatch('edit.html', template_vals)

class Setting_Entry(Helper):
    def post(self):
        post = Prop()
        post.title = self.request.get('title')
        post.title2 = self.request.get('title2')
        post.put()
        self.redirect('/')

class Entry(Helper):
    def post(self):
        x	= ''										# entryp̋̕ϐp
        post = Post()
        post.user = users.get_current_user()
        post.indx  = self.request.get('indx')
        post.title = self.request.get('title')
        x = self.request.get('entry')
        post.entry = x[:500]
        post.entry1 = x[500:1000]
        post.entry2 = x[1000:1500]
        post.entry3 = x[1500:2000]
        post.entry4 = x[2000:2500]
        post.entry5 = x[2500:3000]
        post.entry6 = x[3000:3500]
        post.entry7 = x[3500:4000]
        post.entry8 = x[4000:4500]
        post.entry9 = x[4500:5000]
        post.put()
        self.redirect('/')

class Update(Helper):
    def post(self):
        post = Post().all()					# S擾
        for p in post:
            p.update(self.request, users)
        self.redirect('/')

class Delete(Helper):
    def post(self):
        limit = 50
        post = db.Query(Post).fetch(limit=limit)
        for p in post:
            p.remove(self.request, users)
        self.redirect('/')

class Logout(Helper):
    def post(self):
        user = users.get_current_user()
        if user:
            self.redirect(users.create_logout_url('/'))

